# #
# $Date: 1996/10/10 09:02:14 $ $Author: zimmerma $ $Revision: 1.8 $ #
# #
# zimmerma, 14/12/95 #

#--
	stdlib::solve_eq
--#

stdlib::solve_eq:=proc(eq,x,lev) local d;
begin
   if type(lev)<>DOM_INT then lev:=4 end_if;
   case domtype(eq)
   of DOM_INT do return((if eq=0 then x else null() end_if))
   of DOM_IDENT do # solve(x,x) #
   of DOM_EXPR do
      if type(x)=DOM_FUNC_ENV then error("cannot solve for ".expr2text(x)) end_if;
      if testtype(eq,Type::PolyExpr(x)) then
         return(stdlib::solve_poly(poly(eq,[x]),x,lev))
      elif (d:=denom(eq))<>1 then
         return(op(stdlib::solve_minus({stdlib::solve_eq(numer(eq),x,lev)},
	 	{stdlib::solve_eq(denom(eq),x,lev)})))
      else return(stdlib::isolate(eq,0,x,lev))
      end_if;
   of DOM_POLY do
      if type(lev)<>DOM_INT then lev:=4 end_if;
      return(stdlib::solve_poly(eq,x,lev))
   otherwise
      if eq::constructor=Dom::DistributedPolynomial then
         if type(lev)<>DOM_INT then lev:=4 end_if;
         return(stdlib::solve_poly(op(eq),x,lev))
      end_if;
   end_case;
   null()
end_proc:

stdlib::solve_minus:=proc(s,t) local foo;
begin
   if s={} then s
   else
      t:=select(t,fun(type(args(1))<>Dom::DiscreteSet));
      foo:=subs(fun(not contains(hold(t),args(1))),hold(t)=t);
      map(s,proc(x) begin if type(x)=Dom::DiscreteSet then select(x,foo)
	elif contains(t,x) then null() else x end_if end_proc)
   end_if
end_proc:

# end of file #
